const scraperjs = require('../src/index');

async function main() {
  const { data, finalUrl, queue, screenshot } = await scraperjs.scrape({
    queueItem: {
      url: 'https://reddit.com',
      method: 'home',
    },
    scraper: `
  function main() {
    return {
        use: 'browser',
        start: {
            url: 'https://www.reddit.com/', // The URL that will be used to initialize scraping
            method: 'home' // The method name that will be used to process the start URL
        },
        home({ $, data, queue }) {
            const redditData =  [...document.querySelectorAll('.scrollerItem')].map(x => {
                const he = function(fn, defaultValue) {
                    try {
                        return fn();
                    } catch (err) {
                        console.error(err);
                    return defaultValue;
                    }
                };
                const fixComments = x => x.replace(/ Comments/i, '').replace('comment', '0');
                const comments = fixComments(he(() => x.querySelector('a[data-click-id="comments"]').innerText));
                const score = he(() => x.querySelector('button[aria-label=upvote] ~ div').innerText);
                const title = he(() => x.querySelector('a[data-click-id="body"] h3').innerText);
                const link = he(() => x.querySelector('a[data-click-id="body"]').href);
                if (link === undefined) {
                    return undefined;
                }
                return {
                    comments,
                    score,
                    title,
                    link,
                };
            }).filter(Boolean);
            data(redditData);
        }
    };
  }
  `
  });
  console.log({ data, queue });
};
main();
